
'Klaus D. Raudszus
'Raudszusklaus@aol.com

Option Strict On

Imports System.Collections
Imports System.Windows.Forms
Imports FileInformation.Enumeratoren

'Diese Klasse sortiert die Dateien im FileBrowser (ab- oder aufsteigend)
'beim anklicken der Header-Spalten in der Listview.
Public Class BrowserFileSort
    Implements IComparer

    Protected isAscend As Boolean = True
    Protected SortBy As [Sort] = Sort.ByName

    Public Property Ascending() As Boolean
        Get
            Return isAscend
        End Get
        Set(ByVal Value As Boolean)
            isAscend = Value
        End Set
    End Property

    Public Property SortByCriterion() As [Sort]
        Get
            Return SortBy
        End Get
        Set(ByVal Value As [Sort])
            If SortBy = Value Then
                isAscend = Not isAscend
            Else
                isAscend = True
            End If
            SortBy = Value
        End Set
    End Property
    'Absolute Hammer-Funktion, das Verstndnis dieser Funktion ist ein Mu fr jeden
    'der sich mit .Net beschftigt, deshalb keine weiteren Erklrungen.
    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
                                                   Implements IComparer.Compare
        Dim lviX As ListViewItem = DirectCast(x, ListViewItem)
        Dim lviY As ListViewItem = DirectCast(y, ListViewItem)
        Dim fiX As FileInformation = DirectCast(lviX.Tag, FileInformation)
        Dim fiY As FileInformation = DirectCast(lviY.Tag, FileInformation)
        If fiX Is Nothing Or fiY Is Nothing Then Return 0
        Dim result As Integer
        Select Case SortBy
            Case Sort.ByName
                result = fiX.FileName.CompareTo(fiY.FileName)
            Case Sort.ByExeType
                result = fiX.FileExeType.CompareTo(fiY.FileExeType)
            Case Sort.BySize
                result = fiX.FileLength.CompareTo(fiY.FileLength)
            Case Sort.ByType
                result = fiX.FileType.CompareTo(fiY.FileType)
            Case Sort.ByLastChange
                result = fiX.FileLastChanged.CompareTo(fiY.FileLastChanged)
            Case Sort.ByLastAccess
                result = fiX.FileLastAccess.CompareTo(fiY.FileLastAccess)
            Case Sort.ByAttributes
                result = fiX.FileAttributes.CompareTo(fiY.FileAttributes)
        End Select
        If Not isAscend Then result = -result
        Return result
    End Function

End Class
