
'Klaus D. Raudszus
'Raudszusklaus@aol.com

Option Strict On

Imports System.Xml
Imports System.IO
Imports System.Text

Public Class ConfigClass

    Public m_ItemHeight As Integer = 18
    Public m_Indent As Integer = 19
    Public m_View As String = "Details"
    Public m_Path As String = "C:\"
    
    Protected m_strPath As String = Application.StartupPath & "\Config.xml"

    Public Function CreateConfig() As Boolean
        If File.Exists(m_strPath) Then ReadConfig() : Return False
        Call WriteConfig()
        Return True
    End Function

    Public Sub WriteConfig()
        Dim tw As XmlTextWriter = New XmlTextWriter(m_strPath, Encoding.Default)
        With tw
            .Formatting = Formatting.Indented
            .WriteStartDocument()
            .WriteStartElement("BrowserConfig")
            .WriteElementString("ItemHeight", m_ItemHeight.ToString)
            .WriteElementString("Indent", m_Indent.ToString)
            .WriteElementString("View", m_View.ToString)
            .WriteElementString("Path", m_Path)
            .WriteEndElement()
            .WriteEndDocument()
            .Close()
        End With
    End Sub

    Public Sub ReadConfig()
        Dim tr As XmlTextReader = New XmlTextReader(m_strPath)
        Do While tr.Read()
            Select Case tr.NodeType
                Case XmlNodeType.Element
                    Select Case tr.Name
                        Case "ItemHeight"
                            m_ItemHeight = CInt(tr.ReadString)
                        Case "Indent"
                            m_Indent = CInt(tr.ReadString)
                        Case "View"
                            m_View = tr.ReadString
                        Case "Path"
                            m_Path = tr.ReadString
                    End Select
            End Select
        Loop
        tr.Close()
    End Sub

End Class










