'Klaus D. Raudszus
'Raudszusklaus@aol.com

Option Strict On

Imports System.Security.Permissions
Imports FileInformation
Imports FileInformation.Enumeratoren
Imports System.ComponentModel
Imports DirectoryBrowser
Imports System.Xml
Imports System.IO

<PermissionSetAttribute(SecurityAction.Demand, Name:="FullTrust"), _
ToolboxBitmap(GetType(FolderFileBrowser))> _
Public Class FolderFileBrowser
    Inherits UserControl

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()
        CTE = New CatchThreadException
        AddHandler Application.ThreadException, AddressOf CTE.CatchThreadException
        InitializeComponent()
        AddHandler DirBrowser.Click, AddressOf DirBrowser_Click
        AddHandler DirBrowser.FolderSelectionChanged, AddressOf DirBrowser_FolderSelectionChanged
        FilesBrowser.FolderBrowser = Me.DirBrowser
        AddHandler FilesBrowser.Click, AddressOf FilesBrowser_Click
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents DirBrowser As DirectoryBrowser.DirectoriesBrowser
    Friend WithEvents Splitter1 As System.Windows.Forms.Splitter
    Friend WithEvents FilesBrowser As FileBrowser.FileBrowser

    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.DirBrowser = New DirectoryBrowser.DirectoriesBrowser
        Me.Splitter1 = New System.Windows.Forms.Splitter
        Me.FilesBrowser = New FileBrowser.FileBrowser
        Me.SuspendLayout()
        '
        'DirBrowser
        '
        Me.DirBrowser.BackColor = System.Drawing.SystemColors.Info
        Me.DirBrowser.Dock = System.Windows.Forms.DockStyle.Left
        Me.DirBrowser.Indent = 30
        Me.DirBrowser.ItemHeight = 18
        Me.DirBrowser.Location = New System.Drawing.Point(0, 0)
        Me.DirBrowser.Name = "DirBrowser"
        Me.DirBrowser.Path = Nothing
        Me.DirBrowser.Size = New System.Drawing.Size(240, 300)
        Me.DirBrowser.TabIndex = 4
        '
        'Splitter1
        '
        Me.Splitter1.Location = New System.Drawing.Point(240, 0)
        Me.Splitter1.Name = "Splitter1"
        Me.Splitter1.Size = New System.Drawing.Size(8, 300)
        Me.Splitter1.TabIndex = 6
        Me.Splitter1.TabStop = False
        '
        'FilesBrowser
        '
        Me.FilesBrowser.Dock = System.Windows.Forms.DockStyle.Fill
        Me.FilesBrowser.ListViewView = FileInformation.Enumeratoren.eView.Details
        Me.FilesBrowser.Location = New System.Drawing.Point(248, 0)
        Me.FilesBrowser.Name = "FilesBrowser"
        Me.FilesBrowser.Size = New System.Drawing.Size(260, 300)
        Me.FilesBrowser.TabIndex = 7
        Me.FilesBrowser.View = System.Windows.Forms.View.Details
        '
        'FolderFileBrowser
        '
        Me.Controls.Add(Me.FilesBrowser)
        Me.Controls.Add(Me.Splitter1)
        Me.Controls.Add(Me.DirBrowser)
        Me.Name = "FolderFileBrowser"
        Me.Size = New System.Drawing.Size(508, 300)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Event FileBrowser_Click(ByVal sender As Object, ByVal e As EventArgs)
    Public Event FolderBrowser_Click(ByVal sender As Object, ByVal e As EventArgs)
    Public Event ChangedFolderSelection(ByVal Path As String)

    Protected m_FolderPath As String

    Protected CTE As CatchThreadException

    Protected m_View As eView = eView.Details
    Protected m_intIndent As Integer = 19
    Protected m_intItemHeight As Integer = 18

    Private m_ConfigClass As ConfigClass

    <Browsable(True), _
    EditorBrowsable(EditorBrowsableState.Always), _
    Category("FolderFileBrowserHandling"), _
    Description("Stellt die Ansicht des FileBrowsers um.")> _
    Public Property FileBrowserView() As eView
        Get
            Return m_View
        End Get
        Set(ByVal Value As eView)
            m_View = Value
            Me.FilesBrowser.ListViewView = Value
        End Set
    End Property

    <Browsable(True), _
    EditorBrowsable(EditorBrowsableState.Always), _
    Category("FolderFileBrowserHandling"), _
    Description("Der Abstand fr das Einrcken der " & _
    "einzelnen Ebenen von untergeordneten Strukturknoten ab in Pixel.")> _
    Public Property Indent() As Integer
        Get
            Return m_intIndent
        End Get
        Set(ByVal Value As Integer)
            m_intIndent = Value
            Me.DirBrowser.Indent = Value
        End Set
    End Property

    <Browsable(True), _
    EditorBrowsable(EditorBrowsableState.Always), _
    Category("FolderFileBrowserHandling"), _
    Description("Die Hhe eines Elements im Steuerelement in Pixel.")> _
    Public Property ItemHeight() As Integer
        Get
            Return m_intItemHeight
        End Get
        Set(ByVal Value As Integer)
            m_intItemHeight = Value
            Me.DirBrowser.ItemHeight = Value
        End Set
    End Property

    <Browsable(True), _
    EditorBrowsable(EditorBrowsableState.Always), _
    Category("FolderFileBrowserHandling"), _
    Description("Der zu erffnende Pfad.")> _
    Public Property Path() As String
        Get
            Return m_FolderPath
        End Get
        Set(ByVal Value As String)
            m_FolderPath = Value
            Me.DirBrowser.Path = Value
        End Set
    End Property

    <PermissionSetAttribute(SecurityAction.Demand, Name:="FullTrust")> _
    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)
        m_ConfigClass = New ConfigClass
        m_ConfigClass.CreateConfig()
        ItemHeight = m_ConfigClass.m_ItemHeight
        Indent = m_ConfigClass.m_Indent
        Path = m_ConfigClass.m_Path
        Select Case m_ConfigClass.m_View
            Case "Details"
                FileBrowserView = eView.Details
            Case "List"
                FileBrowserView = eView.List
            Case "LargeIcon"
                FileBrowserView = eView.LargeIcon
            Case "SmallIcon"
                FileBrowserView = eView.SmallIcon
        End Select
        m_ConfigClass = Nothing
    End Sub

    Private Sub FilesBrowser_Click(ByVal sender As Object, ByVal e As EventArgs)
        RaiseEvent FileBrowser_Click(sender, e)
    End Sub

    Private Sub DirBrowser_Click(ByVal sender As Object, ByVal e As EventArgs)
        RaiseEvent FolderBrowser_Click(sender, e)
    End Sub

    Private Sub DirBrowser_FolderSelectionChanged(ByVal sender As Object, ByVal e As DirectoriesBrowser.EventArgs)
        RaiseEvent ChangedFolderSelection(e.Path)
        m_FolderPath = e.Path
    End Sub

End Class








